Imports System
Imports System.Text
Imports System.Data
Imports System.Drawing
Imports System.Data.OleDb
Imports System.Web
Imports System.Web.UI
Imports System.Web.UI.HtmlControls
Imports System.Web.UI.WebControls
Imports System.Configuration.ConfigurationSettings

Namespace PVideo

    Public Class PVideo
        Inherits System.Web.UI.Page

        'GUI data member
        'First level Panel
        Protected menuPanel As System.Web.UI.WebControls.Panel
        Protected rentalPanel As System.Web.UI.WebControls.Panel
        Protected videoPanel As System.Web.UI.WebControls.Panel
        Protected cusPanel As System.Web.UI.WebControls.Panel
        Protected empPanel As System.Web.UI.WebControls.Panel

        'Second level Panel
        Protected msgPanel As System.Web.UI.WebControls.Panel

        Protected rennew_btn As System.Web.UI.WebControls.LinkButton
        Protected newtitle_btn As System.Web.UI.WebControls.LinkButton
        Protected cusnew_btn As System.Web.UI.WebControls.LinkButton
        Protected empnew_btn As System.Web.UI.WebControls.LinkButton

        Protected msgLbl As System.Web.UI.WebControls.Label

        ' ADO.NET data member
        Protected connectionStr As String
        Protected dbAdapter As System.Data.OleDb.OleDbDataAdapter
        Protected dbConnection As System.Data.OleDb.OleDbConnection
        Protected dbCommand As System.Data.OleDb.OleDbCommand
        Protected renDS As System.Data.DataSet
        Protected vidDS As System.Data.DataSet
        Protected cusDS As System.Data.DataSet
        Protected empDS As System.Data.DataSet

        ' temporary data cache
        'Private tempDT As DataTable

        ' ASP.NET data representation member
        Protected WithEvents renDG As System.Web.UI.WebControls.DataGrid
        Protected WithEvents vidDG As System.Web.UI.WebControls.DataGrid
        Protected cusDG As System.Web.UI.WebControls.DataGrid
        Protected empDG As System.Web.UI.WebControls.DataGrid

        ' ASP.NET data representation member for details
        Protected WithEvents renDetailDG As System.Web.UI.WebControls.DataGrid
        Protected WithEvents vidDetailDG As System.Web.UI.WebControls.DataGrid
        Protected WithEvents empDetailDG As System.Web.UI.WebControls.DataGrid
        Protected WithEvents cusDetailDG As System.Web.UI.WebControls.DataGrid
        Private Const GridModeStr As String = "GridMode"
        Private Const ADD As String = "ADD"
        Private Const EDIT As String = "EDIT"

        Private Const dbProperty As String = "PVideoDataBase"

        '_function="ren"
        Private renSet() As String = {"rentals", "renDetails", "renTitles", "renCust", "renEmp"}
        Private Const renQryStr As String = "Select c.ContractID,s.LastName,s.FirstName,c.CustomerID,c.ContractDate,c.Initials,count(d.CopyID) NumVid from Contracts c left outer join Customers s on c.CustomerID = s.CustID left outer join ContDetail d on c.ContractID=d.ContractID group by c.ContractID,s.LastName,s.FirstName,c.CustomerID,c.ContractDate,c.Initials order by c.ContractID"
        Private Const renDetailQryStr As String = "select d.ContractID,d.CopyId SerialNum,d.TitleID,t.Title from ContDetail d inner join Titles t on d.TitleID = t.TitleID order by d.ContractID,t.Title"
        Private Const renTitleQryStr As String = "select c.TitleID,min(c.Copy) Copy,t.Title from Copies c left outer join Titles t on c.TitleID=t.TitleID where c.Status = 0 Group by c.TitleID,Title order by Title,Copy "
        Private Const renCustQryStr As String = "select LastName,FirstName,CustID CustomerID from customers order by LastName, FirstName, CustID"
        Private Const renEmpQryStr As String = "select Initials from Employees where Status = 0"

        '_function="vid"
        Private vidSet() As String = {"videos", "vidDetails", "categories"}
        Private Const vidQryStr As String = "select t.TitleID,t.Title,t.Price,t.Term,count(s.ContractID) NumCopy,c.Description from Titles t left outer join ContDetail s on t.TitleID=s.TitleID left outer join Categories c on t.Category=c.CategoryID Group by t.TitleID,t.Title,t.Price,t.Term,Description Order by t.Title,t.TitleID"
        Private Const vidDetailQryStr As String = "select TitleID,Copy,Status from Copies order by TitleID,Copy,Status"
        Private Const vidCategoryQryStr As String = "select CategoryID, Description from Categories order by Description"
        Private vidHeaders() As String = {"Title", "TitleID", "Description", "Price", "Term"}

        '_function="cus"
        Private cusSet() As String = {"customers"}
        Private Const cusQryStr As String = "Select CustID,LastName,FirstName,Address1,Address2,City,State,Zip,WorkPhone,HomePhone,Status,Member,Expiration,count(ContractID) NumContract from Customers left outer join Contracts on Customers.CustID=Contracts.CustomerID group by custID,LastName,FirstName,Address1,Address2,City,State,Zip,WorkPhone,HomePhone,Status,Member,Expiration order by LastName,CustID"
        Private cusHeaders() As String = {"LastName", "FirstName", "Address1", "Address2", "City", "State", "Zip", "HomePhone", "WorkPhone", "Status", "Member", "Expiration"}

        '_function="emp"
        Private empSet() As String = {"employees"}
        Private Const empQryStr As String = "Select Initials,SSN,LastName,FirstName, Address1,Address2,City,State,Zipcode,Status from Employees order by Initials,LastName, FirstName, State"
        Private empHeaders() As String = {"Initials", "SSN", "LastName", "FirstName", "Address1", "Address2", "City", "State", "Zipcode", "Status"}
        ' shared constants
        Public Const StateStr As String = "State"
        Public Const StatusStr As String = "Status"
        Public Const MemberStr As String = "Member"
        Public stateNameArray() As String = {"AL", "AK", "AZ", "AR", "CA", "CO", "CT", "DE", "DC", "FL", "GA", "HI", "ID", "IL", "IN", "IA", "KS", "KY", "LA", "ME", "MD", "MA", "MI", "MN", "MS", "MO", "MT", "NE", "NV", _
"NH", "NJ", "NM", "NY", "NC", "ND", "OH", "OK", "OR", "PA", "RI", "SC", "SD", "TN", "TX", "UT", "VT", "VA", "WA", "WV", "WI", "WY"}

#Region " Web Form Designer Generated Code "

        'This call is required by the Web Form Designer.
        <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

        End Sub

        Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
            'CODEGEN: This method call is required by the Web Form Designer
            'Do not modify it using the code editor.
            InitializeComponent()
        End Sub

#End Region

        Public Sub New()
            MyBase.New()
            connectionStr = System.Configuration.ConfigurationSettings.AppSettings(dbProperty)
            renDS = Nothing
            vidDS = Nothing
            cusDS = Nothing
            empDS = Nothing
            dbAdapter = Nothing
            dbConnection = Nothing
            dbCommand = Nothing
        End Sub

        Protected Overrides Sub Finalize()
            Try
                If Not dbConnection Is Nothing Then
                    dbConnection.Close()
                End If
            Catch
            Finally
                renDS = Nothing
                vidDS = Nothing
                cusDS = Nothing
                empDS = Nothing
                dbAdapter = Nothing
                dbConnection = Nothing
                dbCommand = Nothing
            End Try

        End Sub

        Private Function OpenConnection() As Boolean
            Dim sb As System.Text.StringBuilder
            Dim ret As Boolean
            ret = True
            sb = New StringBuilder()

            If Not dbConnection Is Nothing And (dbConnection.State = System.Data.ConnectionState.Closed Or dbConnection.State = System.Data.ConnectionState.Broken) Then
                Try
                    dbConnection.Open()
                Catch oe As OleDbException
                    ret = False
                    sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                    sb.AppendFormat("{0}:{1}", oe.GetType.Name, oe.Message)
                    sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                    msgLbl.Text = sb.ToString()
                Finally
                End Try

            End If

            Return (ret And Not dbConnection.State = System.Data.ConnectionState.Closed And Not dbConnection.State = System.Data.ConnectionState.Broken)
        End Function

        ' Perform SELECT
        ' If return False, put a message text into msgLbl for reason
        Private Function DoQuery(ByVal sqlSt As String, ByRef tbl() As String, ByVal ds As DataSet) As Boolean
            Dim ret As Boolean = True
            Dim sb As StringBuilder = New StringBuilder()
            Dim i As Integer

            ' Prerequistion
            If dbConnection Is Nothing Or dbCommand Is Nothing Or dbAdapter Is Nothing Or ds Is Nothing Then
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("DoQuery: NULL ADO.NET Objects")
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
                Return False
            End If

            ' Prerequistion
            If sqlSt = String.Empty Then
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("DoQuery: Require an SQL query statement to complete the function")
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
                Return False
            End If

            Trace.Write("DoQuery: " & sqlSt)

            ' Make sure the connection is open before the adapter fill method. So that the connection remains
            ' open. Open every time is just wasting time and slow
            If OpenConnection() = False Then
                Return False
            End If

            dbCommand.CommandText = sqlSt
            dbAdapter.SelectCommand = dbCommand
            ds.Reset()
            Try
                'Fill will name the first table, 'Table', and the following ones, 'Table1', 'Table2', ...
                dbAdapter.Fill(ds)
            Catch fe As OleDbException
                ret = False
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("{0}:{1}", fe.GetType().Name, fe.Message)
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
            Finally
            End Try
            If ret = True Then
                ' Assuming sqlSt contains one or more than one select statements
                ' We need an array of table names to perform the mapping 
                If Not tbl Is Nothing And tbl.GetLength(0) > 0 Then
                    For i = 0 To tbl.GetLength(0) - 1
                        If i > 0 Then
                            ds.Tables(String.Format("Table{0}", i)).TableName = tbl(i)
                        Else
                            ds.Tables("Table").TableName = tbl(0)
                        End If
                    Next
                End If
            End If
            Return ret
        End Function

        ' Perform UPDATE, INSERT, DELETE
        ' If return False, put a message text into msgLbl for reason
        Private Function DoNonQuery(ByVal sqlSt As String) As Boolean
            Dim ret As Boolean = True
            Dim sb As StringBuilder = New StringBuilder()
            Dim i As Integer = 0

            ' Prerequistion
            If dbConnection Is Nothing Or dbCommand Is Nothing Or dbAdapter Is Nothing Then
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("DoNonQuery: NULL ADO.NET Objects")
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
                Return False
            End If

            ' Prerequistion
            If sqlSt = String.Empty Then
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("DoNonQuery: Require an SQL query statement to complete the function")
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
                Return False
            End If

            ' Make sure the connection is open before the adapter fill method. So that the connection remains
            ' open. Open every time is just wasting time and slow
            If OpenConnection() = False Then
                Return False
            End If

            dbCommand.CommandText = sqlSt
            Try
                ' # of rows affected 
                i = dbCommand.ExecuteNonQuery()
            Catch fe As OleDbException
                ret = False
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("{0}:{1}", fe.GetType().Name, fe.Message)
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
            Finally
            End Try

            If ret = True And i <= 0 Then
                ' ExecuteNoQuery unsuccessful
                ret = False
                sb.AppendFormat("<FONT color={0}#cc6600{1} size={2}+1{3}>", Chr(34), Chr(34), Chr(34), Chr(34))
                sb.AppendFormat("Unsuccessful in {0}", sqlSt)
                sb.AppendFormat("</FONT><Font size={0}-1{1}></FONT>", Chr(34), Chr(34))
                msgLbl.Text = sb.ToString()
            End If
            Return ret
        End Function

        Public Sub Btn_Click(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
            Dim tempDT As DataTable
            Dim dc As DataRow
            Dim sb As StringBuilder
            Dim ret As Boolean = True
            Dim col As DataColumn
            Dim dt As System.DateTime = System.DateTime.Today

            If Not tempDT Is Nothing Then
                tempDT.RejectChanges()
                tempDT = Nothing
            End If
            'Case-sensitive comparison
            If String.Compare(e.CommandName, "empNew", True) = 0 Then
                ret = getEmployees()
                If ret = True Then
                    ' clone structure only
                    tempDT = empDS.Tables(empSet(0)).Clone()
                    For Each col In tempDT.Columns
                        col.AllowDBNull = True
                    Next
                    tempDT.Columns("Initials").DefaultValue = "0000"
                    tempDT.Columns("SSN").DefaultValue = "ddd-dd-dddd"
                    tempDT.Columns("FirstName").DefaultValue = "First Name"
                    tempDT.Columns("LastName").DefaultValue = "Last Name"
                    tempDT.Columns(StateStr).DefaultValue = stateNameArray(0)
                    tempDT.Columns(StatusStr).DefaultValue = 0
                    dc = tempDT.NewRow()
                    tempDT.Rows.Add(dc)

                    ' bind employees grid
                    empPanel.Visible = True
                    empDG.DataSource = empDS.Tables(empSet(0)).DefaultView
                    empDG.DataBind()

                    ' bind employee detail grid
                    empDetailDG.Attributes(GridModeStr) = ADD
                    empDetailDG.EditItemIndex = 0
                    empDetailDG.DataSource = tempDT
                    empDetailDG.DataBind()
                    empDetailDG.Visible = True
                End If

            ElseIf String.Compare(e.CommandName, "vidNew", True) = 0 Then
                ret = getTitles()
                If ret = True Then
                    ' clone structure only
                    For Each col In vidDS.Tables(vidSet(0)).Columns
                        col.AllowDBNull = True
                    Next
                    dc = vidDS.Tables(vidSet(0)).NewRow()
                    dc.Item(vidHeaders(0)) = "Movie Name"
                    dc.Item(vidHeaders(2)) = vidDS.Tables(vidSet(2)).Rows(0).Item(vidHeaders(2))
                    dc.Item(vidHeaders(3)) = 0.0
                    dc.Item(vidHeaders(4)) = 3
                    vidDS.Tables(vidSet(0)).Rows.Add(dc)

                    ' bind videos grid
                    videoPanel.Visible = True
                    vidDG.Attributes(GridModeStr) = ADD
                    ' mark the added row in Edit mode
                    vidDG.EditItemIndex = vidDS.Tables(vidSet(0)).Rows.Count - 1
                    vidDG.DataSource = vidDS.Tables(vidSet(0)).DefaultView()
                    vidDG.DataBind()

                    ' do not show video detail grid
                    vidDetailDG.Visible = False
                End If

            ElseIf String.Compare(e.CommandName, "cusNew", True) = 0 Then
                ret = getCustomers()
                If ret = True Then
                    ' clone structure only
                    tempDT = cusDS.Tables(cusSet(0)).Clone()
                    For Each col In tempDT.Columns
                        col.AllowDBNull = True
                    Next
                    'dt.Columns("CustID").DefaultValue = "0000"
                    tempDT.Columns("HomePhone").DefaultValue = "ddd-ddd-dddd"
                    tempDT.Columns("FirstName").DefaultValue = "First Name"
                    tempDT.Columns("LastName").DefaultValue = "Last Name"
                    tempDT.Columns(StateStr).DefaultValue = stateNameArray(0)
                    tempDT.Columns(StatusStr).DefaultValue = 0
                    tempDT.Columns("Member").DefaultValue = 0
                    dt = dt.AddYears(1)
                    tempDT.Columns("Expiration").DefaultValue = dt.ToShortDateString()
                    dc = tempDT.NewRow()
                    tempDT.Rows.Add(dc)

                    ' bind customers grid
                    cusPanel.Visible = True
                    cusDG.DataSource = cusDS.Tables(cusSet(0)).DefaultView
                    cusDG.DataBind()

                    cusDetailDG.Attributes(GridModeStr) = ADD
                    cusDetailDG.EditItemIndex = 0
                    cusDetailDG.DataSource = tempDT
                    cusDetailDG.DataBind()
                    cusDetailDG.Visible = True
                End If

            ElseIf String.Compare(e.CommandName, "renNew", True) = 0 Then
                ret = getRentals()
                If ret = True Then
                    For Each col In renDS.Tables(renSet(0)).Columns
                        col.AllowDBNull = True
                    Next
                    dc = renDS.Tables(renSet(0)).NewRow()
                    dc.Item("LastName") = "Last Name"
                    dc.Item("FirstName") = "First Name"
                    dc.Item("ContractDate") = System.DateTime.Today
                    dc.Item("NumVid") = 0
                    renDS.Tables(renSet(0)).Rows.Add(dc)

                    ' bind employees grid
                    rentalPanel.Visible = True
                    ' mark the new row in editing mode
                    renDG.EditItemIndex = renDS.Tables(renSet(0)).Rows.Count - 1
                    renDG.DataSource = renDS.Tables(renSet(0)).DefaultView
                    renDG.DataBind()

                    renDetailDG.Visible = False
                End If

            End If

            If ret = False Then
                msgPanel.Visible = True
            End If
        End Sub

        Private Function getRentals() As Boolean
            Dim ret As Boolean
            Dim sb As StringBuilder = New StringBuilder()
            Dim dt As DataTable
            Dim idx As Integer
            ' TitleID starts from 1
            Dim titleID As Integer = 0

            ' we get both contract and contract detail at once
            sb.AppendFormat("{0};{1};{2};{3};{4}", renQryStr, renDetailQryStr, renTitleQryStr, renCustQryStr, renEmpQryStr)

            ret = DoQuery(sb.ToString(), renSet, renDS)
            If ret = True Then
                renDS.Tables(renSet(2)).Columns.Add("TitleAndCopy", Type.GetType("System.String"))
                For idx = 0 To renDS.Tables(renSet(2)).Rows.Count - 1
                    renDS.Tables(renSet(2)).Rows(idx).Item("TitleAndCopy") = String.Format("{0};{1}", renDS.Tables(renSet(2)).Rows(idx).Item("TitleID"), renDS.Tables(renSet(2)).Rows(idx).Item("Copy"))
                Next

                renDS.Tables(renSet(3)).Columns.Add("FullName", Type.GetType("System.String"))
                For idx = 0 To renDS.Tables(renSet(3)).Rows.Count - 1
                    renDS.Tables(renSet(3)).Rows(idx).Item("FullName") = String.Format("{0}, {1}", renDS.Tables(renSet(3)).Rows(idx).Item("LastName"), renDS.Tables(renSet(3)).Rows(idx).Item("FirstName"))
                Next
            End If
            Return ret
        End Function

        Public Sub PageRentals(ByVal source As System.Object, ByVal e As DataGridPageChangedEventArgs)
            Dim ret As Boolean
            ' update the page index
            renDG.CurrentPageIndex = e.NewPageIndex
            ' Refresh the data source and re-bind
            ret = getRentals()
            If ret = True Then
                rentalPanel.Visible = True
                renDetailDG.Visible = False

                renDG.DataSource = renDS.Tables(renSet(0)).DefaultView
                renDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub SortRentals(ByVal source As System.Object, ByVal e As DataGridSortCommandEventArgs)
            Dim ret As Boolean
            Dim dv As DataView
            ret = getRentals()
            If ret = True Then
                rentalPanel.Visible = True
                renDetailDG.Visible = False
                dv = renDS.Tables(renSet(0)).DefaultView
                dv.Sort = e.SortExpression

                renDG.DataSource = dv
                renDG.DataBind()

            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Function GetRenDetailRowCount() As Integer
            Dim dv As DataView = renDetailDG.DataSource
            Return dv.Count
        End Function

        Public Sub renContract(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
            Dim ret As Boolean = True
            Dim dv As DataView
            Dim tr As DataRow
            Dim sb As StringBuilder
            Dim len As Integer
            Dim strParts() As String
            Dim idx As Integer

            If String.Compare(e.CommandName, "renRemoveTitle", True) = 0 Then
                ' get the ContractID part
                strParts = e.CommandArgument.ToString().Split(New Char() {";"c}, 3)
                len = strParts(2).IndexOf("="c)

                sb = New StringBuilder("delete from ContDetail Where ")
                sb.Append(e.CommandArgument.ToString())
                sb.Replace(";", " AND ")
                sb.AppendFormat("; update Copies set Status = 0 where {0} and Copy={1}", strParts(1), strParts(2).Substring(len + 1))
                ret = DoNonQuery(sb.ToString())
            End If

            If ret = True Then
                ret = getRentals()
            End If

            If ret = True Then
                If Not String.Compare(e.CommandName, "renDelete", True) = 0 Then
                    rentalPanel.Visible = True
                    renDG.DataSource = renDS.Tables(renSet(0))
                    renDG.DataBind()
                End If

                ' Case insenstive
                If String.Compare(e.CommandName, "renDetail", True) = 0 Or String.Compare(e.CommandName, "renRemoveTitle", True) = 0 Then
                    dv = renDS.Tables(renSet(1)).DefaultView
                    If String.Compare(e.CommandName, "renDetail", True) = 0 Then
                        dv.RowFilter = e.CommandArgument.ToString()
                    Else
                        dv.RowFilter = strParts(0)
                    End If

                    dv.RowStateFilter = DataViewRowState.OriginalRows

                    renDetailDG.DataSource = dv
                    renDetailDG.DataBind()
                    renDetailDG.Visible = True
                ElseIf String.Compare(e.CommandName, "renAddTitle", True) = 0 Then
                    ' get the ContractID part
                    strParts = e.CommandArgument.ToString().Split(New Char() {"="c}, 2)

                    tr = renDS.Tables(renSet(1)).NewRow()
                    tr.Item("ContractID") = strParts(1)
                    tr.Item("SerialNum") = renDS.Tables(renSet(2)).Rows(0).Item("Copy")
                    tr.Item("TitleID") = renDS.Tables(renSet(2)).Rows(0).Item("TitleID")
                    tr.Item("Title") = renDS.Tables(renSet(2)).Rows(0).Item("Title")
                    renDS.Tables(renSet(1)).Rows.Add(tr)

                    dv = renDS.Tables(renSet(1)).DefaultView
                    dv.RowFilter = e.CommandArgument.ToString()
                    ' including the added new rows
                    dv.RowStateFilter = DataViewRowState.CurrentRows
                    renDetailDG.EditItemIndex = dv.Count - 1
                    renDetailDG.DataSource = dv
                    renDetailDG.DataBind()
                ElseIf String.Compare(e.CommandName, "renDelete", True) = 0 Then
                    dv = renDS.Tables(renSet(1)).DefaultView
                    dv.RowFilter = String.Format("ContractID={0}", e.CommandArgument.ToString())
                    dv.RowStateFilter = DataViewRowState.CurrentRows

                    sb = New StringBuilder("delete from Contracts where ContractID = ")
                    sb.AppendFormat("{0}", e.CommandArgument.ToString())
                    ' we need to scan the contract detail to return each video copy
                    For idx = 0 To dv.Table.Rows.Count - 1
                        If dv.Table.Rows(idx).Item("ContractID") = Integer.Parse(e.CommandArgument.ToString()) Then
                            sb.AppendFormat(";update Copies set status = 0 where titleID={0} And copy={1}", dv.Table.Rows(idx).Item("TitleID"), dv.Table.Rows(idx).Item("SerialNum"))
                        End If
                    Next
                    sb.AppendFormat(";delete from ContDetail where ContractID={0}", e.CommandArgument.ToString())
                    ret = DoNonQuery(sb.ToString())
                    If ret = True Then
                        ret = getRentals()
                    End If

                    If ret = True Then
                        rentalPanel.Visible = True
                        renDG.DataSource = renDS.Tables(renSet(0))
                        renDG.DataBind()
                        renDetailDG.Visible = False
                    End If
                Else
                    renDetailDG.Visible = False
                End If

            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Function GetCustTable() As DataTable
            Return renDS.Tables(renSet(3))
        End Function

        Public Function GetEmpTable() As DataTable
            Return renDS.Tables(renSet(4))
        End Function

        Private Sub renDG_Edit(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDG.EditCommand
            ' set the current item to edit mode
            renDG.EditItemIndex = e.Item.ItemIndex
            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("ren", String.Empty))
        End Sub

        Private Sub renDG_Update(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDG.UpdateCommand
            Dim sb As StringBuilder = New StringBuilder("insert into Contracts (CustomerID,ContractDate,Initials) values(")
            Dim idx As Integer
            Dim ret As Boolean = True
            Dim db As System.Web.UI.WebControls.DropDownList

            ' clear the current item from edit mode
            renDG.EditItemIndex = -1

            ' retrieve the user input and update database
            ' customer info
            db = CType(e.Item.Cells(1).Controls(1), System.Web.UI.WebControls.DropDownList)
            sb.AppendFormat("{0},curDate(),", db.SelectedItem.Value)
            ' employee info
            db = CType(e.Item.Cells(4).Controls(1), System.Web.UI.WebControls.DropDownList)
            sb.AppendFormat("{0}{1}{2})", Chr(39), db.SelectedItem.Value, Chr(39))
            ret = DoNonQuery(sb.ToString())
            If ret = False Then
                msgPanel.Visible = True
            End If

            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("ren", String.Empty))

        End Sub

        Private Sub renDG_Cancel(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDG.CancelCommand
            ' clear the current item from edit mode
            renDG.EditItemIndex = -1

            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("ren", String.Empty))
        End Sub

        Private Sub renDG_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles renDG.ItemCreated
            ' 0-based control collection
            Dim db1 As System.Web.UI.WebControls.DropDownList
            Dim db2 As System.Web.UI.WebControls.DropDownList
            Dim cel As TableCell

            ' Initialize the editing item control for state and status
            If e.Item.ItemType = ListItemType.EditItem Then

                ' get the controls we need to initialize, Controls(0) is literal control that we don't care
                db1 = CType(e.Item.Cells(1).Controls(1), System.Web.UI.WebControls.DropDownList)
                db1.SelectedIndex = -1
                db1.DataTextField = "FullName"

                db2 = CType(e.Item.Cells(4).Controls(1), System.Web.UI.WebControls.DropDownList)
                db2.SelectedIndex = -1

                ' drop the return button in edit mode
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 2), TableCell)
                e.Item.Cells.Remove(cel)
                ' OK and cancel buttons span two columns
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                cel.ColumnSpan = 2
            ElseIf Not e.Item.ItemType = ListItemType.Pager Then
                ' Pager item has one and only one cell in our design
                ' no edit allowed, drop it
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                e.Item.Cells.Remove(cel)
                ' return button spans two columns
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                cel.ColumnSpan = 2
            End If
        End Sub

        Private Sub renDetailDG_Edit(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDetailDG.EditCommand
            Dim args As StringBuilder = New StringBuilder("ContractID=")
            args.Append(e.Item.Cells(0).Text)
            ' set the current item to edit mode
            renDetailDG.EditItemIndex = e.Item.ItemIndex
            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("renDetail", args.ToString()))
        End Sub

        Private Sub renDetailDG_Update(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDetailDG.UpdateCommand
            Dim sb As StringBuilder
            Dim strParts() As String
            Dim ret As Boolean = True
            Dim db As System.Web.UI.WebControls.DropDownList
            Dim txt As System.Web.UI.WebControls.TextBox
            Dim args As StringBuilder = New StringBuilder("ContractID=")

            ' retrieve the user input and update database
            sb = New StringBuilder("insert into ContDetail (ContractID,TitleID,CopyID) values(")

            ' contract id field
            If e.Item.Cells(0).HasControls Then
                If e.Item.Cells(0).Controls.Count > 1 Then
                    txt = CType(e.Item.Cells(0).Controls(1), TextBox)
                Else
                    txt = CType(e.Item.Cells(0).Controls(0), TextBox)
                End If
                sb.Append(txt.Text)
                args.Append(txt.Text)
            Else
                sb.Append(e.Item.Cells(0).Text)
                args.Append(e.Item.Cells(0).Text)
            End If

            ' dropdown list
            db = CType(e.Item.Cells(1).Controls(1), System.Web.UI.WebControls.DropDownList)
            strParts = db.SelectedItem.Value.ToString().Split(New Char() {";"c}, 2)
            sb.AppendFormat(",{0},{1})", strParts(0), strParts(1))
            sb.AppendFormat("; update Copies set status = 1 where TitleId = {0} and copy = {1}", strParts(0), strParts(1))
            ret = DoNonQuery(sb.ToString())
            If ret = False Then
                msgPanel.Visible = True
            End If
            ' clear the current item from edit mode
            renDetailDG.EditItemIndex = -1

            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("renDetail", args.ToString()))

        End Sub

        Private Sub renDetailDG_Cancel(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles renDetailDG.CancelCommand
            Dim sb As StringBuilder = New StringBuilder("ContractID=")
            If e.Item.Cells(0).Text = String.Empty Or e.Item.Cells(0).Text.Length = 0 Then
                sb.Append("0")
            Else
                sb.Append(e.Item.Cells(0).Text)
            End If
            ' clear the current item from edit mode
            renDetailDG.EditItemIndex = -1

            ' refresh view
            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("renDetail", sb.ToString()))
        End Sub

        Private Sub renDetailDG_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles renDetailDG.ItemCreated
            ' 0-based control collection
            Dim titleIdx As Integer = 1
            Dim titles As System.Web.UI.WebControls.DropDownList
            Dim dv As DataRowView
            Dim str As String = String.Empty
            Dim idx As Integer
            Dim cel As TableCell

            ' Initialize the editing item control for state and status
            If e.Item.ItemType = ListItemType.EditItem Then

                ' get the controls we need to initialize, Controls(0) is literal control that we don't care
                titles = CType(e.Item.Cells(titleIdx).Controls(1), System.Web.UI.WebControls.DropDownList)
                titles.DataValueField = "TitleAndCopy"
                ' get the item data as DataRowView object
                dv = e.Item.DataItem

                If Not dv Is Nothing Then
                    For idx = 0 To renDS.Tables(renSet(2)).Rows.Count - 1
                        If String.Compare(dv("Title").ToString(), renDS.Tables(renSet(2)).Rows(idx).Item("Title"), True) = 0 Then
                            Exit For
                        End If
                    Next

                    If Not titles Is Nothing Then
                        titles.SelectedIndex = idx
                    End If
                End If

                ' drop the return button in edit mode
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 2), TableCell)
                e.Item.Cells.Remove(cel)
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                cel.ColumnSpan = 2
            Else
                ' no edit allowed, drop it
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                e.Item.Cells.Remove(cel)
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                cel.ColumnSpan = 2
            End If
        End Sub

        Public Function getRenDetailContractID() As String
            Dim dv As DataView
            dv = renDetailDG.DataSource
            Return dv.RowFilter
        End Function

        Public Function NoVideo(ByVal si As String) As Boolean
            Dim st As Boolean = False
            If String.Compare(si, "0") = 0 Then
                st = True
            End If
            Return st
        End Function

        Public Function GetCategoryTable() As DataTable
            Return vidDS.Tables(vidSet(2))
        End Function

        Private Function getTitles() As Boolean
            Dim ret As Boolean
            Dim sb As StringBuilder = New StringBuilder()
            Dim idx As Integer
            ' we get both contract and contract detail at once
            sb.AppendFormat("{0};{1};{2}", vidQryStr, vidDetailQryStr, vidCategoryQryStr)

            ret = DoQuery(sb.ToString(), vidSet, vidDS)
            Return ret
        End Function

        Public Sub PageVideos(ByVal source As System.Object, ByVal e As DataGridPageChangedEventArgs)
            Dim ret As Boolean
            ' update the page index
            vidDG.CurrentPageIndex = e.NewPageIndex
            ' Refresh the data source and re-bind
            ret = getTitles()
            If ret = True Then
                videoPanel.Visible = True
                vidDetailDG.Visible = False

                vidDG.DataSource = vidDS.Tables(vidSet(0)).DefaultView
                vidDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub SortVideos(ByVal source As System.Object, ByVal e As DataGridSortCommandEventArgs)
            Dim ret As Boolean
            Dim dv As DataView

            ret = getTitles()
            If ret = True Then
                videoPanel.Visible = True
                vidDetailDG.Visible = False

                dv = vidDS.Tables(vidSet(0)).DefaultView
                dv.Sort = e.SortExpression

                vidDG.DataSource = dv
                vidDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Function GetVidDetailStatus(ByVal si As String) As String
            Dim st As String = String.Empty

            Select Case si
                Case "0"
                    st = "Available"
                Case "1"
                    st = "Checked-out"
                Case "2"
                    st = "Overdue"
                Case "3"
                    st = "Missing"
                Case "4"
                    st = "Out of service"
                Case "5"
                    st = "Permanently damaged"
                Case Else
                    st = "Unknown"
            End Select
            Return st
        End Function

        Public Function GetVidDetailRowCount() As Integer
            Dim dv As DataView = vidDetailDG.DataSource
            Return dv.Count
        End Function

        Public Function GetVidDetailRowTitleID() As String
            Dim dv As DataView = vidDetailDG.DataSource
            Return dv.RowFilter
        End Function

        Public Function NoContract(ByVal si As String) As Boolean
            Dim st As Boolean = False
            If String.Compare(si, "0") = 0 Then
                st = True
            End If
            Return st
        End Function

        Public Function IsNotCheckedout(ByVal si As String) As Boolean
            Dim st As Boolean = True
            If String.Compare(si, "1") = 0 Then
                st = False
            End If
            Return st
        End Function

        Public Function GetTitleTable() As DataTable
            Return renDS.Tables(renSet(2))
        End Function

        Public Sub vidTitle(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
            Dim ret As Boolean = True
            Dim dv As DataView
            Dim sb As StringBuilder
            Dim strParts() As String
            Dim len As Integer
            Dim tb As DataTable
            Dim tr As DataRow
            Dim idx As Integer
            Dim maxCopy As Integer = 0

            If String.Compare(e.CommandName, "vidDelete", True) = 0 Then
                ' delete the title and all its copies
                sb = New StringBuilder("delete from Titles where TitleID = ")
                sb.AppendFormat("{0}; delete from Copies where TitleID = {1}", e.CommandArgument.ToString(), e.CommandArgument.ToString())
                ret = DoNonQuery(sb.ToString())
            ElseIf String.Compare(e.CommandName, "vidDeleteCopy", True) = 0 Then
                ' delete the specific copy
                sb = New StringBuilder("delete from Copies where ")
                sb.Append(e.CommandArgument.ToString())
                sb.Replace(";", " AND ")
                ret = DoNonQuery(sb.ToString())
            End If

            If ret = True Then
                ret = getTitles()
            End If

            If ret = True Then
                videoPanel.Visible = True
                vidDG.DataSource = vidDS.Tables(vidSet(0)).DefaultView
                vidDG.DataBind()

                ' Case insenstive
                If String.Compare(e.CommandName, "vidDetail", True) = 0 Or String.Compare(e.CommandName, "vidDeleteCopy", True) = 0 Then
                    dv = vidDS.Tables(vidSet(1)).DefaultView
                    If String.Compare(e.CommandName, "vidDeleteCopy", True) = 0 Then
                        ' get the TitleID part
                        strParts = e.CommandArgument.ToString().Split(New Char() {";"c}, 2)
                        dv.RowFilter = strParts(0)
                    Else
                        dv.RowFilter = e.CommandArgument.ToString()
                    End If

                    dv.RowStateFilter = DataViewRowState.OriginalRows

                    vidDetailDG.DataSource = dv
                    vidDetailDG.DataBind()
                    vidDetailDG.Visible = True
                ElseIf String.Compare(e.CommandName, "vidAddCopy", True) = 0 Then
                    ' get the titleID value, storing it in strParts(1)
                    strParts = e.CommandArgument.ToString().Split(New Char() {"="c}, 2)
                    tb = vidDS.Tables(vidSet(1))
                    For idx = 0 To tb.Rows.Count - 1
                        ' table contains all records of table, Copies, filtering based on TitleID
                        If CType(tb.Rows(idx).Item(0), Integer) = Integer.Parse(strParts(1)) And CType(tb.Rows(idx).Item(1), Integer) > maxCopy Then
                            maxCopy = CType(tb.Rows(idx).Item(1), Integer)
                        End If
                    Next
                    tr = tb.NewRow()
                    'titleID
                    tr.Item(0) = strParts(1)
                    'Copy
                    tr.Item(1) = maxCopy + 1
                    'Status
                    tr.Item(2) = 0
                    ' add this new record
                    tb.Rows.Add(tr)
                    sb = New StringBuilder("insert into Copies (TitleID,Copy,Status) values(")
                    sb.AppendFormat("{0},{1},0)", strParts(1), tr.Item(1).ToString())
                    ret = DoNonQuery(sb.ToString())
                    If ret = True Then
                        dv = tb.DefaultView
                        dv.RowFilter = e.CommandArgument.ToString()
                        'including the added new row
                        dv.RowStateFilter = DataViewRowState.CurrentRows
                        vidDetailDG.DataSource = dv
                        vidDetailDG.DataBind()
                    Else
                        msgPanel.Visible = True
                    End If
                Else
                    vidDetailDG.Visible = False
                End If
            Else
                msgPanel.Visible = True
            End If

        End Sub

        Private Sub vidDG_Edit(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles vidDG.EditCommand
            ' set the current item to edit mode
            vidDG.EditItemIndex = e.Item.ItemIndex
            vidDG.Attributes(GridModeStr) = EDIT
            ' refresh view
            vidTitle(sender, New System.Web.UI.WebControls.CommandEventArgs("vid", String.Empty))
        End Sub

        Private Sub vidDG_Update(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles vidDG.UpdateCommand
            Dim sb As StringBuilder
            Dim idxArray() As Integer = {0, 2, 3, 4}
            Dim idx As Integer
            Dim dollarIdx As Integer
            Dim ret As Boolean = True
            Dim db As System.Web.UI.WebControls.DropDownList
            Dim txt As System.Web.UI.WebControls.TextBox

            ' retrieve the user input and update database
            If String.Compare(vidDG.Attributes(GridModeStr), ADD) = 0 Then
                sb = New StringBuilder("insert into Titles (title,Category,price,term) values(")
                For Each idx In idxArray
                    If idx > 0 Then
                        sb.Append(",")
                    End If
                    If Not idx = 2 Then
                        'textbox
                        If e.Item.Cells(idx).HasControls Then
                            If e.Item.Cells(idx).Controls.Count > 1 Then
                                txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                            Else
                                txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                            End If
                            If idx = 0 Then
                                ' title field
                                sb.AppendFormat("{0}{1}{2}", Chr(39), txt.Text, Chr(39))
                            Else
                                dollarIdx = txt.Text.IndexOf("\")
                                If dollarIdx >= 0 Then
                                    sb.Append(txt.Text.Substring(dollarIdx + 1))
                                Else
                                    sb.Append(txt.Text)
                                End If
                            End If
                        Else
                            sb.Append(e.Item.Cells(idx).Text)
                        End If

                    Else
                        ' dropdown list
                        db = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.Append(db.SelectedItem.Value.ToString())
                    End If
                Next
                sb.Append(")")
            Else
                sb = New StringBuilder("update Titles set ")
                For Each idx In idxArray
                    If idx > 0 Then
                        sb.Append(",")
                    End If
                    If Not idx = 2 Then
                        'textbox
                        If e.Item.Cells(idx).HasControls Then
                            If e.Item.Cells(idx).Controls.Count > 1 Then
                                txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                            Else
                                txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                            End If
                            If idx = 0 Then
                                ' title field
                                sb.AppendFormat("{0}={1}{2}{3}", vidHeaders(idx), Chr(39), txt.Text, Chr(39))
                            Else
                                dollarIdx = txt.Text.IndexOf("\")
                                If dollarIdx >= 0 Then
                                    sb.AppendFormat("{0}={1}", vidHeaders(idx), txt.Text.Substring(dollarIdx + 1))
                                Else
                                    sb.AppendFormat("{0}={1}", vidHeaders(idx), txt.Text)
                                End If
                            End If
                        Else
                            sb.AppendFormat("{0}={1}", vidHeaders(idx), e.Item.Cells(idx).Text)
                        End If
                    Else
                        ' dropdown list
                        db = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.AppendFormat("Category={0}", db.SelectedItem.Value.ToString())
                    End If
                Next
                sb.AppendFormat(" Where TitleID = {0}", e.Item.Cells(1).Text)
            End If

            ret = DoNonQuery(sb.ToString())
            If ret = False Then
                msgPanel.Visible = True
            End If
            ' clear the current item from edit mode
            vidDG.EditItemIndex = -1
            vidDG.Attributes(GridModeStr) = String.Empty

            ' refresh view
            vidTitle(sender, New System.Web.UI.WebControls.CommandEventArgs("vid", String.Empty))

        End Sub

        Private Sub vidDG_Cancel(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles vidDG.CancelCommand
            ' clear the current item from edit mode
            vidDG.EditItemIndex = -1
            vidDG.Attributes(GridModeStr) = String.Empty

            ' refresh view
            vidTitle(sender, New System.Web.UI.WebControls.CommandEventArgs("vid", String.Empty))
        End Sub

        Private Sub vidDG_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles vidDG.ItemCreated
            ' 0-based control collection
            Dim categoryCtrlIdx As Integer = 2
            Dim categories As System.Web.UI.WebControls.DropDownList
            Dim dv As DataRowView
            Dim idx As Integer
            Dim cel As TableCell

            ' Initialize the editing item control for state and status
            If e.Item.ItemType = ListItemType.EditItem Then

                ' get the controls we need to initialize, Controls(0) is literal control that we don't care
                categories = CType(e.Item.Cells(categoryCtrlIdx).Controls(1), System.Web.UI.WebControls.DropDownList)
                ' get the item data as DataRowView object
                dv = e.Item.DataItem

                If Not dv Is Nothing Then
                    For idx = 0 To vidDS.Tables(vidSet(2)).Rows.Count - 1
                        If String.Compare(dv(vidHeaders(2)).ToString(), vidDS.Tables(vidSet(2)).Rows(idx).Item(vidHeaders(2)), True) = 0 Then
                            Exit For
                        End If
                    Next
                    categories.SelectedIndex = idx
                End If

                ' hide the remove button in edit mode
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 2), TableCell)
                e.Item.Cells.Remove(cel)
                cel = CType(e.Item.Cells(e.Item.Cells.Count - 1), TableCell)
                cel.ColumnSpan = 2
                'e.Item.Cells(vidHeaders.Length).Enabled = False

            End If
        End Sub

        Private Function getCustomers() As Boolean
            Dim ret As Boolean
            ret = DoQuery(cusQryStr, cusSet, cusDS)
            Return ret
        End Function

        Public Sub PageCustomers(ByVal source As System.Object, ByVal e As DataGridPageChangedEventArgs)
            Dim ret As Boolean
            ' update the page index
            cusDG.CurrentPageIndex = e.NewPageIndex
            ' Refresh the data source and re-bind
            ret = getCustomers()
            If ret = True Then
                cusPanel.Visible = True

                cusDG.DataSource = cusDS.Tables(cusSet(0)).DefaultView
                cusDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub SortCustomers(ByVal source As System.Object, ByVal e As DataGridSortCommandEventArgs)
            Dim ret As Boolean
            Dim dv As DataView

            ret = getCustomers()
            If ret = True Then
                cusPanel.Visible = True

                dv = cusDS.Tables(cusSet(0)).DefaultView
                dv.Sort = e.SortExpression

                cusDG.DataSource = dv
                cusDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub custInfo(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
            Dim ret As Boolean = True
            Dim sb As StringBuilder
            Dim dv As DataView
            Dim len As Integer

            If String.Compare(e.CommandName, "cusDelete", True) = 0 Then
                sb = New StringBuilder("delete from Customers where CustID=")
                sb.Append(e.CommandArgument.ToString())
                ret = DoNonQuery(sb.ToString())
            End If

            If ret = True Then
                ret = getCustomers()
            End If

            If ret = True Then
                cusPanel.Visible = True
                cusDG.DataSource = cusDS.Tables(cusSet(0)).DefaultView
                cusDG.DataBind()
                ' Case insenstive
                If String.Compare(e.CommandName, "cusDetail", True) = 0 Or String.Compare(e.CommandName, "cusEdit", True) = 0 Or String.Compare(e.CommandName, "cusCancel", True) = 0 Then
                    dv = cusDS.Tables(cusSet(0)).DefaultView
                    dv.RowFilter = e.CommandArgument.ToString()
                    dv.RowStateFilter = DataViewRowState.OriginalRows

                    If String.Compare(e.CommandName, "cusDetail", True) = 0 And String.Compare(cusDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                        cusDetailDG.Attributes(GridModeStr) = String.Empty
                    End If
                    cusDetailDG.DataSource = dv
                    cusDetailDG.DataBind()
                    If dv.Count > 0 Then
                        cusDetailDG.Visible = True
                    Else
                        cusDetailDG.Visible = False
                    End If

                Else
                    cusDetailDG.Visible = False
                End If
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Function HoldContract(ByVal si As String) As Boolean
            Dim st As Boolean = True
            If String.Compare(si, "0") = 0 Then
                st = False
            End If
            ' Not holding contract
            Return Not st
        End Function

        Public Function cusStatusInDetail(ByVal si As Integer) As String
            Dim st As String
            If si = 0 Then
                st = "Green"
            ElseIf si = 1 Then
                st = "Yellow"
            Else
                st = "Red"
            End If
            Return st
        End Function

        Private Sub cusDetailDG_Edit(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles cusDetailDG.EditCommand
            Trace.Write("cusDetailDG_Edit: selected item index = " & e.Item.ItemIndex.ToString())
            Dim sb As StringBuilder = New StringBuilder("CustID=")
            sb.Append(e.Item.Cells(0).Text)

            ' Set the current item in Editing mode
            cusDetailDG.EditItemIndex = e.Item.ItemIndex
            cusDetailDG.Attributes(GridModeStr) = EDIT

            ' Refresh view
            custInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("cusEdit", sb.ToString()))

        End Sub

        Private Sub cusDetailDG_Update(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles cusDetailDG.UpdateCommand
            Dim idx As Integer
            Dim len As Integer = e.Item.Cells.Count - 2
            Dim sb As StringBuilder
            Dim args As StringBuilder = New StringBuilder("CustID = ")
            Dim states As System.Web.UI.WebControls.DropDownList
            Dim status As System.Web.UI.WebControls.RadioButtonList
            Dim member As System.Web.UI.WebControls.CheckBox
            Dim txt As System.Web.UI.WebControls.TextBox
            Dim dateArray() As String
            Dim ret As Boolean = True

            If cusHeaders.Length - 1 < len Then
                len = cusHeaders.Length - 1
            End If

            'retrieve the input and update the data source
            If String.Compare(cusDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                args.Append("0")
                'custID is identity that is auto-incremented
                sb = New StringBuilder("insert into customers (LastName,FirstName,Address1,Address2,City,State,Zip,HomePhone,WorkPhone,Status,Member,Expiration) values( ")
                ' skip the last cells
                For idx = 0 To len
                    If idx > 0 Then
                        sb.Append(",")
                    End If

                    If String.Compare(cusHeaders(idx), StateStr, True) = 0 Then
                        states = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.AppendFormat("{0}{1}{2}", Chr(39), stateNameArray(states.SelectedIndex), Chr(39))
                    ElseIf String.Compare(cusHeaders(idx), StatusStr, True) = 0 Then
                        status = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.RadioButtonList)
                        sb.AppendFormat("{0}", status.SelectedIndex)
                    ElseIf String.Compare(cusHeaders(idx), MemberStr, True) = 0 Then
                        member = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.CheckBox)
                        If member.Checked = True Then
                            sb.AppendFormat("1")
                        Else
                            sb.AppendFormat("0")
                        End If
                    ElseIf String.Compare(cusHeaders(idx), "Expiration", True) = 0 Then
                        If e.Item.Cells(idx).Controls.Count = 1 Then
                            txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                        Else
                            txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        End If

                        dateArray = txt.Text.Split(New Char() {"/"c}, 3)
                        If dateArray.Length >= 3 Then
                            sb.AppendFormat("{0}{1}-{2}-{3}{4}", Chr(39), dateArray(0).PadLeft(4, "2"c), dateArray(1).PadLeft(2, "0"c), dateArray(2).PadLeft(2, "0"c), Chr(39))
                        Else
                            sb.Append("null")
                        End If
                    ElseIf e.Item.Cells(idx).HasControls = True Then
                        If e.Item.Cells(idx).Controls.Count = 1 Then
                            txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                        Else
                            txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        End If
                        sb.AppendFormat("{0}{1}{2}", Chr(39), txt.Text.ToString(), Chr(39))
                    Else
                        sb.AppendFormat("{0}{1}{2}", Chr(39), e.Item.Cells(idx).Text.ToString(), Chr(39))
                    End If
                Next
                sb.Append(")")
            Else
                args.Append(e.Item.Cells(0).Text)
                sb = New StringBuilder("update customers set ")

                ' skip the first and last cells
                For idx = 1 To len + 1
                    If idx > 1 Then
                        sb.Append(",")
                    End If

                    If String.Compare(cusHeaders(idx - 1), StateStr, True) = 0 Then
                        states = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.AppendFormat("{0}={1}{2}{3}", cusHeaders(idx - 1), Chr(39), stateNameArray(states.SelectedIndex), Chr(39))
                    ElseIf String.Compare(cusHeaders(idx - 1), StatusStr, True) = 0 Then
                        status = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.RadioButtonList)
                        sb.AppendFormat("{0}={1}", cusHeaders(idx - 1), status.SelectedIndex)
                    ElseIf String.Compare(cusHeaders(idx - 1), MemberStr, True) = 0 Then
                        member = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.CheckBox)
                        If member.Checked = True Then
                            sb.AppendFormat("{0}=1", cusHeaders(idx - 1))
                        Else
                            sb.AppendFormat("{0}=0", cusHeaders(idx - 1))
                        End If
                    ElseIf String.Compare(cusHeaders(idx - 1), "Expiration", True) = 0 Then
                        If e.Item.Cells(idx).Controls.Count > 1 Then
                            txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        Else
                            txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                        End If

                        dateArray = txt.Text.Split(New Char() {"/"c}, 3)
                        If dateArray.Length >= 3 Then
                            sb.AppendFormat("{0}={1}{2}-{3}-{4}{5}", cusHeaders(idx - 1), Chr(39), dateArray(0).PadLeft(4, "2"c), dateArray(1).PadLeft(2, "0"c), dateArray(2).PadLeft(2, "0"c), Chr(39))
                        End If
                    ElseIf e.Item.Cells(idx).HasControls = True Then
                        If e.Item.Cells(idx).Controls.Count = 1 Then
                            txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                        Else
                            txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        End If
                        sb.AppendFormat("{0}={1}{2}{3}", cusHeaders(idx - 1), Chr(39), txt.Text.ToString(), Chr(39))
                    Else
                        sb.AppendFormat("{0}={1}{2}{3}", cusHeaders(idx - 1), Chr(39), e.Item.Cells(idx).Text.ToString(), Chr(39))
                    End If
                Next
                sb.AppendFormat(" where CustID = {0}", e.Item.Cells(0).Text)
            End If

            ret = DoNonQuery(sb.ToString())
            If ret = False Then
                msgPanel.Visible = True
            End If

            ' Reset the edit mode for the current item
            cusDetailDG.EditItemIndex = -1

            ' Refresh view
            cusDetailDG.Attributes(GridModeStr) = String.Empty
            If String.Compare(empDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                custInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("cusCancel", args.ToString()))
            Else
                custInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("cusDetail", args.ToString()))
            End If
        End Sub

        Private Sub cusDetailDG_Cancel(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles cusDetailDG.CancelCommand
            Dim sb As StringBuilder = New StringBuilder("CustID=")
            If e.Item.Cells(0).Text = String.Empty Or e.Item.Cells(0).Text.Length = 0 Then
                sb.Append("0")
            Else
                sb.Append(e.Item.Cells(0).Text)
            End If

            ' Reset the current item mode
            cusDetailDG.EditItemIndex = -1

            ' Refresh view
            cusDetailDG.Attributes(GridModeStr) = String.Empty
            custInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("cusCancel", sb.ToString()))
        End Sub

        Private Sub cusDetailDG_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles cusDetailDG.ItemCreated
            ' 0-based control collection
            Dim stateCtrlIdx As Integer = 6
            Dim statusCtrlIdx As Integer = 10
            Dim memberCtrlIdx As Integer = 11
            Dim states As System.Web.UI.WebControls.DropDownList
            Dim status As System.Web.UI.WebControls.RadioButtonList
            Dim member As System.Web.UI.WebControls.CheckBox
            Dim dv As DataRowView
            Dim str As String = String.Empty
            Dim idx As Integer
            Dim cell As TableCell

            ' hide both header and content cell for the ID cell
            If String.Compare(cusDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                ' hide the id field, i.e., remove it
                cell = CType(e.Item.Cells(0), TableCell)
                e.Item.Cells.Remove(cell)
                ' shift left one cell
                stateCtrlIdx = stateCtrlIdx - 1
                statusCtrlIdx = statusCtrlIdx - 1
                memberCtrlIdx = memberCtrlIdx - 1
            End If

            ' Initialize the editing item control for state and status
            If e.Item.ItemType = ListItemType.EditItem Then

                ' get the controls we need to initialize, Controls(0) is literal control that we don't care
                states = CType(e.Item.Cells(stateCtrlIdx).Controls(1), System.Web.UI.WebControls.DropDownList)
                status = CType(e.Item.Cells(statusCtrlIdx).Controls(1), System.Web.UI.WebControls.RadioButtonList)
                member = CType(e.Item.Cells(memberCtrlIdx).Controls(1), System.Web.UI.WebControls.CheckBox)
                ' get the item data as DataRowView object
                dv = e.Item.DataItem

                If Not dv Is Nothing Then
                    str = dv(StateStr).ToString()
                    idx = Array.IndexOf(stateNameArray, str)
                    If Not states Is Nothing Then
                        states.SelectedIndex = idx
                    End If

                    idx = dv(StatusStr).ToString()
                    If Not status Is Nothing Then
                        status.SelectedIndex = idx
                    End If

                    If Not member Is Nothing Then
                        If String.Compare(dv(MemberStr).ToString(), "True", True) = 0 Then
                            member.Checked = True
                        End If
                    End If
                End If
            End If
        End Sub

        Private Function getEmployees() As Boolean
            Dim ret As Boolean
            ret = DoQuery(empQryStr, empSet, empDS)
            Return ret
        End Function

        Public Sub PageEmployees(ByVal source As System.Object, ByVal e As DataGridPageChangedEventArgs)
            Dim ret As Boolean
            ' update the page index
            empDG.CurrentPageIndex = e.NewPageIndex
            ' Refresh the data source and re-bind
            ret = getEmployees()
            If ret = True Then
                empPanel.Visible = True

                empDG.DataSource = empDS.Tables(empSet(0)).DefaultView
                empDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub SortEmployees(ByVal source As System.Object, ByVal e As DataGridSortCommandEventArgs)
            Dim ret As Boolean
            Dim dv As DataView

            ret = getEmployees()
            If ret = True Then
                empPanel.Visible = True

                dv = empDS.Tables(empSet(0)).DefaultView
                dv.Sort = e.SortExpression

                empDG.DataSource = dv
                empDG.DataBind()
            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Sub empInfo(ByVal source As System.Object, ByVal e As System.Web.UI.WebControls.CommandEventArgs)
            Dim ret As Boolean = True
            Dim dv As DataView
            Dim sb As StringBuilder
            Dim len As Integer

            If String.Compare(e.CommandName, "empDelete", True) = 0 Then
                sb = New StringBuilder("delete from Employees where Initials=")
                ' initial is an String that had to be quoted
                sb.AppendFormat("{0}{1}{2}", Chr(39), e.CommandArgument.ToString(), Chr(39))
                ret = DoNonQuery(sb.ToString())
            End If

            If ret = True Then
                ret = getEmployees()
            End If

            If ret = True Then
                empPanel.Visible = True
                empDG.DataSource = empDS.Tables(empSet(0)).DefaultView
                empDG.DataBind()

                ' Case insenstive
                If String.Compare(e.CommandName, "empDetail", True) = 0 Or String.Compare(e.CommandName, "empEdit", True) = 0 Or String.Compare(e.CommandName, "empCancel", True) = 0 Then
                    dv = empDS.Tables(empSet(0)).DefaultView
                    dv.RowFilter = e.CommandArgument.ToString()
                    dv.RowStateFilter = DataViewRowState.OriginalRows

                    If String.Compare(e.CommandName, "empDetail", True) = 0 And String.Compare(empDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                        empDetailDG.Attributes(GridModeStr) = EDIT
                    End If

                    empDetailDG.DataSource = dv
                    empDetailDG.DataBind()
                    If dv.Count > 0 Then
                        empDetailDG.Visible = True
                    Else
                        empDetailDG.Visible = False
                    End If
                Else
                    empDetailDG.Visible = False
                End If

            Else
                msgPanel.Visible = True
            End If
        End Sub

        Public Function empStatusInDetail(ByVal si As Integer) As String
            Dim st As String
            If si = 0 Then
                st = "Active"
            Else
                st = "Inactive"
            End If
            Return st
        End Function

        Private Sub empDetailDG_Edit(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles empDetailDG.EditCommand
            Dim sb As StringBuilder = New StringBuilder("Initials=")

            sb.AppendFormat("{0}{1}{0}", Chr(39), e.Item.Cells(0).Text, Chr(39))

            ' Set the current item in Editing mode
            empDetailDG.EditItemIndex = e.Item.ItemIndex
            empDetailDG.Attributes(GridModeStr) = EDIT

            ' Refresh view
            empInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("empEdit", sb.ToString()))

        End Sub

        Private Sub empDetailDG_Update(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles empDetailDG.UpdateCommand
            'retrieve the input and update the data source
            Dim idx As Integer
            Dim len As Integer = e.Item.Cells.Count - 2
            Dim sb As StringBuilder
            Dim args As StringBuilder = New StringBuilder("Initials = ")
            Dim states As System.Web.UI.WebControls.DropDownList
            Dim status As System.Web.UI.WebControls.RadioButtonList
            Dim txt As System.Web.UI.WebControls.TextBox
            Dim ret As Boolean = True

            If empHeaders.Length - 1 < len Then
                len = empHeaders.Length - 1
            End If

            'retrieve the input and update the data source
            If String.Compare(empDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                args.AppendFormat("{0}0000{1}", Chr(39), Chr(39))
                'custID is identity that is auto-incremented
                sb = New StringBuilder("insert into employees (Initials,SSN,LastName,FirstName,Address1,Address2,City,State,Zipcode,Status) values( ")
                ' skip the last cells
                For idx = 0 To len
                    If idx > 0 Then
                        sb.Append(",")
                    End If

                    If String.Compare(empHeaders(idx), StateStr, True) = 0 Then
                        states = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.AppendFormat("{0}{1}{2}", Chr(39), stateNameArray(states.SelectedIndex), Chr(39))
                    ElseIf String.Compare(empHeaders(idx), StatusStr, True) = 0 Then
                        status = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.RadioButtonList)
                        sb.AppendFormat("{0}", status.SelectedIndex)
                    ElseIf e.Item.Cells(idx).HasControls = True Then
                        If e.Item.Cells(idx).Controls.Count = 1 Then
                            txt = CType(e.Item.Cells(idx).Controls(0), TextBox)
                        Else
                            txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        End If
                        sb.AppendFormat("{0}{1}{2}", Chr(39), txt.Text.ToString(), Chr(39))
                    Else
                        sb.AppendFormat("{0}{1}{2}", Chr(39), e.Item.Cells(idx).Text.ToString(), Chr(39))
                    End If
                Next
                sb.Append(")")
            Else
                sb = New StringBuilder("update employees set ")

                ' skip the first and last cells, cell(0) is read-only
                For idx = 1 To len
                    If idx > 1 Then
                        sb.Append(",")
                    End If

                    If String.Compare(empHeaders(idx), StateStr, True) = 0 Then
                        states = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.DropDownList)
                        sb.AppendFormat("{0}={1}{2}{3}", empHeaders(idx), Chr(39), stateNameArray(states.SelectedIndex), Chr(39))
                    ElseIf String.Compare(empHeaders(idx), StatusStr, True) = 0 Then
                        status = CType(e.Item.Cells(idx).Controls(1), System.Web.UI.WebControls.RadioButtonList)
                        sb.AppendFormat("{0}={1}", empHeaders(idx), status.SelectedIndex)
                    Else
                        txt = CType(e.Item.Cells(idx).Controls(1), TextBox)
                        sb.AppendFormat("{0}={1}{2}{3}", empHeaders(idx), Chr(39), txt.Text.ToString(), Chr(39))
                    End If
                Next
                If e.Item.Cells(0).HasControls Then
                    If e.Item.Cells(0).Controls.Count = 1 Then
                        txt = CType(e.Item.Cells(0).Controls(0), System.Web.UI.WebControls.TextBox)
                    Else
                        txt = CType(e.Item.Cells(0).Controls(1), System.Web.UI.WebControls.TextBox)
                    End If
                    sb.AppendFormat(" where Initials = {0}{1}{2}", Chr(39), txt.Text.ToString(), Chr(39))
                    args.AppendFormat("{0}{1}{2}", Chr(39), txt.Text.ToString(), Chr(39))
                Else
                    sb.AppendFormat(" where Initials = {0}{1}{2}", Chr(39), e.Item.Cells(0).Text.ToString(), Chr(39))
                    args.AppendFormat("{0}{1}{2}", Chr(39), e.Item.Cells(0).Text.ToString(), Chr(39))
                End If
            End If

            ret = DoNonQuery(sb.ToString())
            If ret = False Then
                msgPanel.Visible = True
            End If

            ' Reset the edit mode for the current item
            empDetailDG.EditItemIndex = -1

            ' Refresh view
            empDetailDG.Attributes(GridModeStr) = String.Empty
            If String.Compare(empDetailDG.Attributes(GridModeStr), ADD) = 0 Then
                empInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("empCancel", args.ToString()))
            Else
                empInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("empDetail", args.ToString()))
            End If

        End Sub

        Private Sub empDetailDG_Cancel(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs) Handles empDetailDG.CancelCommand
            Dim sb As StringBuilder = New StringBuilder("Initials=")
            Dim tb As TextBox = CType(e.Item.Cells(0).Controls(0), TextBox)
            sb.AppendFormat("{0}{1}{0}", Chr(39), tb.Text, Chr(39))

            ' Reset the current item mode
            empDetailDG.EditItemIndex = -1
            empDetailDG.Attributes(GridModeStr) = String.Empty
            empInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("empCancel", sb.ToString()))

        End Sub

        Private Sub empDetailDG_ItemCreated(ByVal sender As System.Object, ByVal e As System.Web.UI.WebControls.DataGridItemEventArgs) Handles empDetailDG.ItemCreated
            ' 0-based control collection
            Dim initialsCtrlIdx As Integer = 0
            Dim stateCtrlIdx As Integer = 7
            Dim statusCtrlIdx As Integer = 9
            Dim states As System.Web.UI.WebControls.DropDownList
            Dim status As System.Web.UI.WebControls.RadioButtonList
            Dim initials As System.Web.UI.WebControls.TextBox
            Dim dv As DataRowView
            Dim str As String = String.Empty
            Dim idx As Integer

            ' Initialize the editing item control for state and status
            If e.Item.ItemType = ListItemType.EditItem Then
                ' get the controls we need to initialize, Controls(0) is literal control that we don't care
                states = CType(e.Item.Cells(stateCtrlIdx).Controls(1), System.Web.UI.WebControls.DropDownList)
                status = CType(e.Item.Cells(statusCtrlIdx).Controls(1), System.Web.UI.WebControls.RadioButtonList)

                ' get the item data as DataRowView object
                dv = e.Item.DataItem

                If Not dv Is Nothing Then
                    str = dv(StateStr).ToString()
                    idx = Array.IndexOf(stateNameArray, str)
                    If Not states Is Nothing Then
                        states.SelectedIndex = idx
                    End If

                    idx = dv(StatusStr).ToString()
                    If Not status Is Nothing Then
                        status.SelectedIndex = idx
                    End If
                End If

                initials = CType(e.Item.Cells(initialsCtrlIdx).Controls(0), System.Web.UI.WebControls.TextBox)
                initials.Columns = 3
                initials.MaxLength = 4

                If String.Compare(empDetailDG.Attributes(GridModeStr), EDIT) = 0 Then
                    initials.ReadOnly = True
                    initials.BackColor = System.Drawing.Color.FromArgb(240, 248, 255)
                    initials.BorderStyle = BorderStyle.None
                End If

            End If
        End Sub

        Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
            'Put user code to initialize the page here
            Dim params As System.Collections.Specialized.NameValueCollection = Nothing
            Dim allKeys() As String
            Dim i As Int16

            'Prepare to perform database access. Therefore the first time the page is loaded, it is slow
            Try
                renDS = New Data.DataSet()
                renDS.EnforceConstraints = False
            Catch x As System.OutOfMemoryException
                renDS = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                renDS = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If renDS Is Nothing Then
                Return
            End If

            Try
                vidDS = New Data.DataSet()
                vidDS.EnforceConstraints = False
            Catch x As System.OutOfMemoryException
                vidDS = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                vidDS = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If vidDS Is Nothing Then
                Return
            End If

            Try
                cusDS = New Data.DataSet()
                cusDS.EnforceConstraints = False
            Catch x As System.OutOfMemoryException
                cusDS = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                cusDS = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If cusDS Is Nothing Then
                Return
            End If

            Try
                empDS = New Data.DataSet()
                empDS.EnforceConstraints = False
            Catch x As System.OutOfMemoryException
                empDS = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                empDS = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If empDS Is Nothing Then
                Return
            End If

            Try
                dbConnection = New OleDb.OleDbConnection(connectionStr)
            Catch x As System.OutOfMemoryException
                dbConnection = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                dbConnection = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If dbConnection Is Nothing Then
                Return
            End If

            Try
                dbAdapter = New OleDb.OleDbDataAdapter()
            Catch x As System.OutOfMemoryException
                dbAdapter = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                dbAdapter = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If dbAdapter Is Nothing Then
                Return
            End If
            dbAdapter.MissingMappingAction = MissingMappingAction.Passthrough
            dbAdapter.MissingSchemaAction = MissingSchemaAction.AddWithKey

            Try
                dbCommand = New OleDb.OleDbCommand()
                dbCommand.Connection = dbConnection
                dbCommand.CommandType = System.Data.CommandType.Text
            Catch x As System.OutOfMemoryException
                dbCommand = Nothing
                Trace.Write(x.GetType.Name & ":" & x.Message)
            Catch y As System.Exception
                dbCommand = Nothing
                Trace.Write(y.GetType.Name & ":" & y.Message)
            Finally
            End Try
            If dbCommand Is Nothing Then
                Return
            End If

            If Not IsPostBack Then
                ' see if we are referenced by other pages.
                ' in this case, there must have _function as parts of the requesting URL
                allKeys = Request.QueryString.AllKeys
                If allKeys.Length > 0 Then
                    params = Request.QueryString
                End If
            Else
                allKeys = Request.Form.AllKeys
                If allKeys.Length > 0 Then
                    params = Request.Form
                End If
            End If

            'All panels are invisible by default
            menuPanel.Visible = False
            rentalPanel.Visible = False
            videoPanel.Visible = False
            cusPanel.Visible = False
            empPanel.Visible = False

            'hide conditional displayed panels
            msgPanel.Visible = False

            If allKeys.Length = 0 Then
                menuPanel.Visible = True
            Else
                For i = 0 To allKeys.Length - 1
                    If String.Compare(allKeys(i), "_function", False) = 0 Then
                        If String.Compare(params(allKeys(i)).ToString(), "ren", False) = 0 Then
                            renContract(sender, New System.Web.UI.WebControls.CommandEventArgs("ren", String.Empty))
                        ElseIf String.Compare(params(allKeys(i)).ToString(), "vid", False) = 0 Then
                            vidTitle(sender, New System.Web.UI.WebControls.CommandEventArgs("vid", String.Empty))
                        ElseIf String.Compare(params(allKeys(i)).ToString(), "cus", False) = 0 Then
                            custInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("cus", String.Empty))
                        ElseIf String.Compare(params(allKeys(i)).ToString(), "emp", False) = 0 Then
                            empInfo(sender, New System.Web.UI.WebControls.CommandEventArgs("emp", String.Empty))
                        Else
                            ' default
                            menuPanel.Visible = True
                        End If
                    End If
                Next
            End If
        End Sub
    End Class

End Namespace
