<%@ Page Language="vb" AutoEventWireup="false" Codebehind="PVideo.aspx.vb" Inherits="PVideo.PVideo.PVideo"%>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML>
	<HEAD>
		<title>PVideo</title>
		<meta content="Microsoft Visual Studio.NET 7.0" name="GENERATOR">
		<meta content="Visual Basic 7.0" name="CODE_LANGUAGE">
		<meta content="JavaScript" name="vs_defaultClientScript">
		<meta content="http://schemas.microsoft.com/intellisense/ie5" name="vs_targetSchema">
		<LINK rel="stylesheet" type="text/css" href="techdocs.css" />
	</HEAD>
	<BODY MS_POSITIONING="GridLayout">
		<!-- The following JavaScript code allows the program to be run in framed or non-framed mode -->
		<script language="javascript">
		
	 if (top.frames.length <= 1 )
	 {
	   document.writeln('<H1><img src="p_logo.gif">Pervasive Video Rental Management</H1>');
	   document.writeln('<P>This sample shows a demo version of a Video Store management program. ');
	   document.writeln('The use of the ADO.NET replaces the use of ADODB while the interface' );
	   document.writeln('is written in ASP.NET. The decision of using VB.NET' ); 
	   document.writeln('is to be consistent with the term, VB, in the previous version.' );
	   document.writeln('Run program in <A href="Index.html" target="_top">frames mode</A>.</P>' );
	   document.writeln('<P>Go to <A href="PVideo.aspx">Main Menu</A>.</P>' );
	 }
	 
	 function wintarget( loc )
	 {
	    if ( top.length <= 1 )
	    {
	      location.href = "PVideo.aspx?_function=" + loc;
	    }
	    else
	    {
	      parent.right.location.href = "PVideo.aspx?_function=" + loc;
	    } 
	 }
		</script>
		<form id="PVideo" method="post" runat="server">
			<asp:panel id="menuPanel" runat="server" HorizontalAlign="Left">
				<H2>Main Menu</H2>
				<P>Please select from the following menu choices:</P>
				<P><BUTTON style="WIDTH: 120px; TEXT-INDENT: 1en; TEXT-ALIGN: center" onclick='wintarget("ren");' type="button">Rental Contracts</BUTTON>
				</P>
				<P><BUTTON style="WIDTH: 120px; TEXT-INDENT: 1en; TEXT-ALIGN: center" onclick='wintarget("vid");' type="button">Video Titles</BUTTON>
				</P>
				<P><BUTTON style="WIDTH: 120px; TEXT-INDENT: 1en; TEXT-ALIGN: center" onclick='wintarget("cus");' type="button">Customer Info</BUTTON>
				</P>
				<P><BUTTON style="WIDTH: 120px; TEXT-INDENT: 1en; TEXT-ALIGN: center" onclick='wintarget("emp");' type="button">Employee Info</BUTTON>
				</P>
				<P><BUTTON style="WIDTH: 120px; TEXT-INDENT: 1en; TEXT-ALIGN: center" onclick='top.location.href="http://www.agtech.co.jp/developer/psql/"' type="button">Exit Program</BUTTON>
				</P>
			</asp:panel><asp:panel id="rentalPanel" HorizontalAlign="Center" Runat="server">
				<H2>Rental Contract Listing</H2>
				<p align="center"><asp:LinkButton id="rennew_btn" Runat="server" CausesValidation="False" CommandName="renNew" OnCommand="Btn_click">
					<FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a New Rental Contract</U></FONT>
					</asp:LinkButton></p>
				<P>Click on contract <u>ID</u> to get full detail. Click on <u>underlined header</u> to sort by different orders.</P>
				<asp:DataGrid id="renDG" Runat="server" AutoGenerateColumns="False" CellPadding="2" AllowSorting="True" OnSortCommand="SortRentals" ShowHeader="True" AllowCustomPaging="False" AllowPaging="True" PageSize="10" OnPageIndexChanged="PageRentals">
					<AlternatingItemStyle BackColor="LemonChiffon" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<PagerStyle BackColor="LemonChiffon" ForeColor="Mediumblue" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Right" BorderStyle="Solid" PageButtonCount="10" Mode="NumericPages" Position="TopAndBottom" BorderWidth="1" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<Columns>
						<asp:TemplateColumn HeaderText="<u>Contract ID</u>" SortExpression="ContractID" HeaderStyle-Font-Underline="True">
							<ItemTemplate>
								<asp:LinkButton OnCommand="renContract" CommandArgument='<%# String.Format("ContractID={0}", DataBinder.Eval(Container.DataItem, "ContractID"))%>' CommandName="renDetail" Runat="server" Font-Size="Smaller" ToolTip="Rental Details">
									<%# DataBinder.Eval(Container.DataItem, "ContractID")%>
								</asp:LinkButton>
							</ItemTemplate>
							<EditItemTemplate >
							   <asp:Label runat="server" />
							</EditItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn HeaderText="<u>Customer Name</u>" SortExpression="LastName, FirstName" HeaderStyle-Font-Underline="True">
							<ItemTemplate>
								<asp:Label Runat="server">
										<%# DataBinder.Eval(Container.DataItem, "LastName")%>, <%# DataBinder.Eval(Container.DataItem, "FirstName")%>
										</asp:Label>
							</ItemTemplate>
							<EditItemTemplate>
							  <asp:DropDownList Runat="server" DataSource='<%# GetCustTable() %>' DataValueField="CustomerID" />
							</EditItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn  HeaderText="Customer ID" >
						    <ItemTemplate>
							   <asp:Label runat="server">
							     <%# DataBinder.Eval(Container.DataItem, "CustomerID" ) %>
							   </asp:Label>
                            </ItemTemplate> 
                            <EditItemTemplate>
                                 <asp:Label runat="server" />
                            </EditItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataFormatString="{0:d}" ItemStyle-Font-Size="Smaller" HeaderText="<u>Contract Date</u>" DataField="ContractDate" SortExpression="ContractDate" HeaderStyle-Font-Underline="True" Readonly="True" />
						<asp:TemplateColumn HeaderText="Employee Initial" >
							<ItemTemplate >
							    <asp:Label Runat="server" >
							       <%# DataBinder.Eval(Container.DataItem, "Initials") %>
							    </asp:Label>
                            </ItemTemplate>
                            <EditItemTemplate>
                              <asp:DropDownList Runat="server"  DataSource='<%# GetEmpTable() %>' DataTextField="Initials" DataValueField="Initials" />
                            </EditItemTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Text="Return" OnCommand="renContract" CommandArgument='<%# DataBinder.Eval(Container.DataItem, "ContractID")%>' CommandName="renDelete" Runat="server" Font-Size="Smaller" ToolTip="Click to delete" />
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:EditCommandColumn  EditText="Change" CancelText="Cancel" UpdateText="OK" ButtonType="PushButton"/>
					</Columns>
				</asp:DataGrid>
				<p>&nbsp;</p>
				<asp:DataGrid id="renDetailDG" Runat="server" AutoGenerateColumns="False" CellPadding="4" ShowHeader="True" ShowFooter="True">
					<AlternatingItemStyle BackColor="LemonChiffon" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<FooterStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Left" Font-Name="arial" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<SelectedItemStyle BackColor="#f0f8ff" />					
					<Columns>
						<asp:BoundColumn HeaderText="Contract ID" FooterText="Total # of Videos" DataField="ContractID" ReadOnly="True" />
						<asp:TemplateColumn HeaderText="Title">
							<ItemTemplate>
								<asp:Label Runat="server">
									<%# DataBinder.Eval(Container.DataItem, "Title")%>
								</asp:Label>
							</ItemTemplate>
							<EditItemTemplate>
							    <asp:DropDownList Runat="server" DataSource='<%# GetTitleTable() %>' DataTextField='Title'  />
							</EditItemTemplate>
							<FooterTemplate>
								<asp:Label Runat="server">
									<%# GetRenDetailRowCount() %>
								</asp:Label>
							</FooterTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn HeaderText="Serial Number" >
							<ItemTemplate>
							    <asp:Label Runat="server">
									<%# DataBinder.Eval(Container.DataItem, "SerialNum")%>
								</asp:Label>
							</ItemTemplate>
							<EditItemTemplate>
							   <asp:Label Runat="server" Visible="False" />
							</EditItemTemplate>
							<FooterTemplate>
								<asp:LinkButton Runat="server" CausesValidation="False" CommandName="renAddTitle" CommandArgument='<%# getRenDetailContractID() %>' OnCommand="renContract" >
                               	<FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a Video</U></FONT>
                               </asp:LinkButton>
							</FooterTemplate>
						</asp:TemplateColumn>
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Text="Return" OnCommand="renContract" CommandArgument='<%# String.Format("ContractID={0};TitleID={1};CopyID={2}",DataBinder.Eval(Container.DataItem,"ContractID"),DataBinder.Eval(Container.DataItem, "TitleID"),DataBinder.Eval(Container.DataItem, "SerialNum")) %>' CommandName="renRemoveTitle" Runat="server" Font-Size="Smaller" ToolTip="Click to remove" />
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:EditCommandColumn EditText="Edit" CancelText="Cancel" UpdateText="OK"  ButtonType="PushButton" />
					</Columns>
				</asp:DataGrid>
			</asp:panel><asp:panel id="videoPanel" HorizontalAlign="Center" Runat="server">
				<H2>Video Title Listing</H2>
				<P align="center">Titles are arranged alphabetically.
				<asp:LinkButton id="newtitle_btn" Runat="server" CausesValidation="False" CommandName="Vidnew" OnCommand="Btn_click">
					 <FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a New Title</U></FONT>
					</asp:LinkButton></P>
				<p>Click on <u>movie name</u> to get detail. Click on <u>underlined header</u> to sort by different orders.</P>
				<asp:DataGrid id="vidDG" Runat="server" AutoGenerateColumns="False" CellPadding="2" AllowSorting="True" OnSortCommand="SortVideos" ShowHeader="True" AllowCustomPaging="False" AllowPaging="True" PageSize="10" OnPageIndexChanged="PageVideos" >
					<AlternatingItemStyle BackColor="#CCFFCC" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<PagerStyle BackColor="#CCFFCC" ForeColor="Mediumblue" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Right" BorderStyle="Solid" PageButtonCount="10" Mode="NumericPages" Position="TopAndBottom" BorderWidth="1" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<EditItemStyle BackColor="#f0f8ff" />
					<SelectedItemStyle BackColor="#f0f8ff" />
					<Columns>
						<asp:TemplateColumn HeaderText="<u>Title</u>" SortExpression="Title, TitleID" >
							<ItemTemplate>
								<asp:LinkButton OnCommand="vidTitle" CommandArgument='<%# String.Format("TitleID={0}",DataBinder.Eval(Container.DataItem, "TitleID")) %>' CommandName="vidDetail" Runat="server" Font-Size="Smaller" ToolTip="Title Details">
									<%# DataBinder.Eval(Container.DataItem, "Title")%>
								</asp:LinkButton>
							</ItemTemplate>
							<EditItemTemplate>
							  <asp:TextBox Runat="server" TextMode="SingleLine" Width="280px" Text='<%# String.Format("{0}",DataBinder.Eval(Container.DataItem, "Title"))%>' />
							</EditItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="Title ID" DataField="TitleID" ReadOnly="True"/>
						<asp:TemplateColumn HeaderText="<u>Category</u>" SortExpression="Description, Title, TitleID">
						 <ItemTemplate>
						   <asp:Label Runat="server" >
						    <%# DataBinder.Eval(Container.DataItem, "Description" ) %>
						   </asp:Label>
						 </ItemTemplate>
						 <EditItemTemplate>
                           <asp:dropdownlist Runat="server" DataSource='<%# GetCategoryTable() %>' DataTextField="Description" DataValueField="CategoryID" />
                         </EditItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn DataFormatString="{0:c}" ItemStyle-Font-Size="Smaller" HeaderText="Price" DataField="Price" />
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="Rental Term" DataField="Term" />
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Text="Remove" Enabled='<%# NoContract( DataBinder.Eval(Container.DataItem, "NumCopy")) %>' OnCommand="vidTitle" CommandArgument='<%# DataBinder.Eval(Container.DataItem, "TitleID")%>' CommandName="vidDelete" Runat="server" Font-Size="Smaller" ToolTip="Click to remove">
								</asp:Button>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:EditCommandColumn EditText="Edit" CancelText="Cancel" UpdateText="OK"  ButtonType="PushButton"  />
					</Columns>
				</asp:DataGrid>
				<p>&nbsp;</p>
				<asp:DataGrid id="vidDetailDG" Runat="server" AutoGenerateColumns="False" CellPadding="4" ShowHeader="True" ShowFooter="True" >
					<AlternatingItemStyle BackColor="#CCFFCC" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<FooterStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Left" Font-Name="arial" />
					<SelectedItemStyle BackColor="#f0f8ff" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<Columns>
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="Title ID" DataField="TitleID" FooterText="Total # of Copies" />					
						<asp:TemplateColumn HeaderText="Serial Number" >
							<ItemTemplate>
								<asp:Label Runat="server">
								 <%# DataBinder.Eval(Container.DataItem, "Copy")%>
								</asp:Label>
							</ItemTemplate>
							<FooterTemplate>
							  <asp:Label Runat="server">
							       <%# GetVidDetailRowCount() %>
							  </asp:Label>
							</FooterTemplate>
						</asp:TemplateColumn>
                        <asp:TemplateColumn HeaderText="Status" >
							<ItemTemplate>
								<asp:Label Runat="server">
									<%# GetVidDetailStatus(DataBinder.Eval(Container.DataItem, "Status"))%>
								</asp:Label>
							</ItemTemplate>
							<FooterTemplate>
								<asp:LinkButton Runat="server" CausesValidation="False" CommandName="vidAddCopy" CommandArgument='<%# GetVidDetailRowTitleID() %>' OnCommand="vidTitle" >
                               	  <FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a Copy</U></FONT>
                               </asp:LinkButton>
							</FooterTemplate>							
						</asp:TemplateColumn>						
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Enabled='<%# IsNotCheckedout(DataBinder.Eval(Container.DataItem, "Status")) %>' Text="Remove" OnCommand="vidTitle" CommandArgument=<%# String.Format("TitleID={0};Copy={1}",DataBinder.Eval(Container.DataItem, "TitleID"),DataBinder.Eval(Container.DataItem, "Copy"))%> CommandName="vidDeleteCopy" Runat="server" Font-Size="Smaller" ToolTip="Click to remove">
								</asp:Button>
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:DataGrid>
			</asp:panel>
			<asp:Panel ID="cusPanel" Runat="server" HorizontalAlign="Center">
				<H2>Customer Listing</H2>
				<P align="center">Customers are arranged alphaetically.
				<asp:LinkButton id="cusnew_btn" Runat="server" CausesValidation="False" CommandName="cusNew" OnCommand="Btn_click">
					 <FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a New Customer</U></FONT>
					</asp:LinkButton></P>
				<P>Click on <u>last name</u> to get full detail. Click on <u>underlined header</u> to sort by different orders.</P>
				<asp:DataGrid id="cusDG" Runat="server" AutoGenerateColumns="False" CellPadding="2" AllowSorting="True" OnSortCommand="SortCustomers" ShowHeader="True" AllowCustomPaging="False" AllowPaging="True" PageSize="10" OnPageIndexChanged="PageCustomers">
					<AlternatingItemStyle BackColor="#FFCCFF" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<PagerStyle BackColor="#FFCCFF" ForeColor="Mediumblue" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Right" BorderStyle="Solid" PageButtonCount="10" Mode="NumericPages" Position="TopAndBottom" BorderWidth="1" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<Columns>
						<asp:TemplateColumn HeaderText="<u>Last Name</u>" SortExpression="LastName, FirstName, CustID" >
							<ItemTemplate>
								<asp:LinkButton OnCommand="custInfo" CommandArgument='<%# String.Format("CustID={0}", DataBinder.Eval(Container.DataItem, "CustID")) %>' CommandName="cusDetail" Runat="server" Font-Size="Smaller" ToolTip="Customer Details">
									<%# DataBinder.Eval(Container.DataItem, "LastName")%>
								</asp:LinkButton>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="<u>First Name</u>" DataField="FirstName" SortExpression="FirstName, LastName, CustID" />
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="<u>Customer ID</u>" DataField="CustID" SortExpression="CustID, LastName, FirstName" />
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Text="Delete" Enabled='<%# HoldContract(DataBinder.Eval(Container.DataItem, "NumContract")) %>' OnCommand="custInfo" CommandArgument='<%# DataBinder.Eval(Container.DataItem, "CustID") %>' CommandName="cusDelete" Runat="server" Font-Size="Smaller" ToolTip="Click to delete">
								</asp:Button>
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:DataGrid>
				<p>&nbsp;</p>
				<asp:DataGrid ID="cusDetailDG" HorizontalAlign="Left" Runat="server"  AutoGenerateColumns="False" CellPadding="4" ShowHeader="True" EditItemStyle-BackColor="#f0f8ff"  >
					<AlternatingItemStyle BackColor="#CCFFFF" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="False" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />			
					<SelectedItemStyle BackColor="#f0f8ff" />
                <Columns>
                  <asp:BoundColumn HeaderText="ID" DataField="CustID" Readonly="True" />
                  <asp:TemplateColumn HeaderText="Last Name">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "LastName" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="148px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "LastName") ) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>                  
                  <asp:TemplateColumn HeaderText="First Name">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "FirstName" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="148px" text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "FirstName" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>
                   <asp:TemplateColumn HeaderText="Address Line 1">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "Address1" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="252px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "Address1" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>
                  <asp:TemplateColumn HeaderText="Address Line 2">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "Address2" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="168px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "Address2" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>   
                  <asp:TemplateColumn HeaderText="City">
                    <ItemTemplate>
                     <asp:Label Runat="server" >
                       <%# DataBinder.Eval( Container.DataItem, "City" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="168px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "City" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>    
                  <asp:TemplateColumn HeaderText="State">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "State" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:dropdownlist Runat="server" DataSource='<%# stateNameArray %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn> 
                   <asp:TemplateColumn HeaderText="Zip">
                    <ItemTemplate>
                     <asp:Label Runat="server" >
                       <%# DataBinder.Eval( Container.DataItem, "Zip" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="70px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "Zip" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>
                  <asp:TemplateColumn HeaderText="Home Phone" >
                    <ItemTemplate>
                     <asp:Label Runat="server" >
                       <%# DataBinder.Eval( Container.DataItem, "HomePhone" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="84px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "HomePhone" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>                  
                  <asp:TemplateColumn HeaderText="WorkPhone" >
                    <ItemTemplate>
                     <asp:Label Runat="server" >
                       <%# DataBinder.Eval( Container.DataItem, "WorkPhone" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="84px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "WorkPhone" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>                  
                  <asp:TemplateColumn HeaderText="Status">
                    <ItemTemplate>
                    <asp:Label Runat="server" >
                      <%# cusStatusInDetail( DataBinder.Eval(Container.DataItem, "Status" )) %>
                    </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:RadioButtonList Runat="Server" AutoPostBack="False" RepeatColumns="1" RepeatLayout="Table" Font-Size="smaller">
                        <asp:ListItem Value="0">Green</asp:ListItem>
                        <asp:ListItem Value="1">Yellow</asp:ListItem>
                        <asp:ListItem Value="2">Red</asp:ListItem>
                      </asp:RadioButtonList>
                    </EditItemTemplate>
                  </asp:TemplateColumn>
                  <asp:TemplateColumn HeaderText="Member" >
                    <ItemTemplate>
                     <asp:CheckBox Runat="server" Checked=<%# DataBinder.Eval( Container.DataItem, "Member" ) %> />
                    </ItemTemplate>
                  </asp:TemplateColumn> 
                  <asp:BoundColumn HeaderText="Expiration Date" DataFormatString="{0:d}" DataField="Expiration" />                        
                  <asp:EditCommandColumn EditText="Edit" UpdateText="OK" CancelText="Cancel" ButtonType="PushButton" />                                                           
                </Columns>                  
				</asp:DataGrid>				
			</asp:Panel>
			<asp:Panel ID="empPanel" Runat="server" HorizontalAlign="Center">
				<H2>Employee Listing</H2>
				<P align="center">Employees are arranged alphabetically. 
				<asp:LinkButton id="empnew_btn" Runat="server" CausesValidation="False" CommandName="empNew" OnCommand="Btn_click" >
					 <FONT face="verdana,arial,helvetica" color="#4169e1" size="-1"><U>Add a New Employee</U></FONT>
					</asp:LinkButton></P>
				<P>Click on <U>initial</U> to get full detail. Click on <u>underlined header</u> to sort by different orders.</P>
				<asp:DataGrid id="empDG" Runat="server" AutoGenerateColumns="False" CellPadding="2" AllowSorting="True" OnSortCommand="SortEmployees" ShowHeader="True" AllowCustomPaging="False" AllowPaging="True" PageSize="10" OnPageIndexChanged="PageEmployees">
					<AlternatingItemStyle BackColor="#CCFFFF" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<PagerStyle BackColor="#CCFFFF" ForeColor="Mediumblue" Font-Bold="True" Font-Size="Smaller" HorizontalAlign="Right" BorderStyle="Solid" PageButtonCount="10" Mode="NumericPages" Position="TopAndBottom" BorderWidth="1" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />
					<Columns>
						<asp:TemplateColumn HeaderText="<u>Initials</u>" SortExpression="Initials"  >
							<ItemTemplate>
								<asp:LinkButton OnCommand="empInfo" CommandArgument='<%# String.Format("Initials={0}{1}{2}",chr(39),DataBinder.Eval(Container.DataItem, "Initials"),chr(39)) %>' CommandName="empDetail" Runat="server" Font-Size="Smaller" ToolTip="Employee Details">
									<%# DataBinder.Eval(Container.DataItem, "Initials")%>
								</asp:LinkButton>
							</ItemTemplate>
						</asp:TemplateColumn>
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="<u>Last Name</u>" DataField="LastName" SortExpression="LastName, FirstName, Initials, State "  />
						<asp:BoundColumn ItemStyle-Font-Size="Smaller" HeaderText="<u>First Name</u>" DataField="FirstName" SortExpression="FirstName, LastName, Initials, State"  />
						<asp:TemplateColumn>
							<ItemTemplate>
								<asp:Button Text="Delete" OnCommand="empInfo" CommandArgument='<%# DataBinder.Eval(Container.DataItem, "Initials") %>' CommandName="empDelete" Runat="server" Font-Size="Smaller" ToolTip="Click to delete" />
							</ItemTemplate>
						</asp:TemplateColumn>
					</Columns>
				</asp:DataGrid>
				<p>&nbsp;</p>
				<asp:DataGrid ID="empDetailDG"  HorizontalAlign="Left" Runat="server" AutoGenerateColumns="False" CellPadding="4" ShowHeader="True" EditItemStyle-BackColor="#f0f8ff"  >
					<AlternatingItemStyle BackColor="#CCFFFF" Font-Size="Smaller" />
					<HeaderStyle BackColor="LightGrey" Font-Bold="False" Font-Size="Smaller" HorizontalAlign="Center" Font-Name="arial" />
					<ItemStyle Font-Size="Smaller" Font-Name="verdana" HorizontalAlign="Center" />			
					<SelectedItemStyle BackColor="#f0f8ff" />
                <Columns>
                  <asp:BoundColumn HeaderText="Initials" DataField="Initials"  />
                  <asp:TemplateColumn HeaderText="Social Security" >
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "SSN" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="77px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "SSN" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>                  
                  <asp:TemplateColumn HeaderText="Last Name">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "LastName" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="148px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "LastName") ) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>                  
                  <asp:TemplateColumn HeaderText="First Name">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "FirstName" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="148px" text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "FirstName" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>
                   <asp:TemplateColumn HeaderText="Address Line 1">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "Address1" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="252px" Text='<%# String.Format("{0}",DataBinder.Eval( Container.DataItem, "Address1" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>
                  <asp:TemplateColumn HeaderText="Address Line 2">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "Address2" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="168px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "Address2" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>   
                  <asp:TemplateColumn HeaderText="City">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "City" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="168px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "City" )) %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn>    
                  <asp:TemplateColumn HeaderText="State">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "State" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:dropdownlist Runat="server" DataSource='<%# stateNameArray %>' />
                    </EditItemTemplate>                    
                  </asp:TemplateColumn> 
                   <asp:TemplateColumn HeaderText="Zip">
                    <ItemTemplate>
                     <asp:Label Runat="server">
                       <%# DataBinder.Eval( Container.DataItem, "Zipcode" ) %>
                     </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:TextBox Runat="server" TextMode="SingleLine" Width="70px" Text='<%# String.Format("{0}", DataBinder.Eval( Container.DataItem, "Zipcode" )) %>' />
                    </EditItemTemplate>
                  </asp:TemplateColumn>      
                  <asp:TemplateColumn HeaderText="Status">
                    <ItemTemplate>
                       <asp:Label Runat="server">
                       <%# empStatusInDetail( DataBinder.Eval(Container.DataItem, "Status" )) %>
                       </asp:Label>
                    </ItemTemplate>
                    <EditItemTemplate>
                      <asp:RadioButtonList Runat="Server" AutoPostBack="False" RepeatColumns="1" RepeatLayout="Table" Font-size="smaller">
                        <asp:ListItem Value="0">Active</asp:ListItem>
                        <asp:ListItem Value="1">Inactive</asp:ListItem>
                      </asp:RadioButtonList>
                    </EditItemTemplate>
                  </asp:TemplateColumn>           
                  <asp:EditCommandColumn EditText="Edit" UpdateText="OK" CancelText="Cancel" ButtonType="PushButton" />                                                          
                </Columns>                  
				</asp:DataGrid>
			</asp:Panel>
			<asp:Panel ID="msgPanel" Runat="server" HorizontalAlign="Left">
				<P>
					<asp:Label id="msgLbl" runat="server" Font-Names="arial,verdana,helvetica">
						<FONT color="#cc6600" size="+1">The record has been changed for </FONT><Font size="-1">
						</Font>
					</asp:Label></P>
			</asp:Panel></form>
	</BODY>
</HTML>
